' Funktionen, die fuer mehrere Programmteile benoetigt werden
chdir exepath
#include once "vbcompat.bi"

const SMischen = 1, SSprung = 2, SAuto = 4, SGesperrt = 8, SVerdeckt = 16, SStopp1 = 32, SStopp2 = 64
const SFarbstart = 128, SWertstart = 256, SQuer = 512, SBelegt = 2^10, SVoll = 2*2^10, SFrei = 3*2^10
const SJoker = 2^12
const MOr = 0, MAnd = 1024, MXor = 2048
const SsLeer = 1, SsBelegt = 2, SsBelegbar = 3, SsVoll = 4, SsStopp = 5, SsKeinStopp = 6, SsSumme = 7
const SsLegen = 8, SsNehmen = 16, SsInaktiv = 32
const VGleich = 1*2^8, VGroesser = 2*2^8, VKleiner = 4*2^8, VVergleich = VGleich or VGroesser or VKleiner
const VFarbwechsel = 1*2^11, VFarbgleich = 2*2^11, VFarbSR = 3*2^11, VFarbungleich = 4*2^11
const VFarbvergleich = VFarbwechsel or VFarbgleich or VFarbSR or VFarbungleich
const ROben = 1, RUnten = 2, RLinks = 4, RRechts = 8
const ASumme = 48, AKartenzahl = 16, AFarbe = 32, AWert = 48
const ATypLinks = 1, ATypRechts = 2, ATypMitte = 4, ATypLegen = 8, ATypFrei = 15
const ATypAbschluss = 16, ATypIrreversibel = 32, ATypBeginn = 64, ATypSieg = 128, ATypVerlust = 256
const ATypKlick = ATypLinks or ATypRechts, ATypEnde = ATypSieg or ATypVerlust
const ChEinzel = 0, ChId = 1, ChKomplett = 2, ChGesamt = 3, ChTausch = 4, ChMischen = 2^3
const ChAenderung = 2^4, ChLegen = 2*2^4, ChSound = 3*2^4, ChWarten = 4*2^4, ChMeldung = 2^7
const ChLegeRueckwaerts = 2^8, ChLegeMischen = 2^9, ChLegeZufall = 2^10
const ChEinschubHinten = 2^11, ChEinschubZufall = 2^12, ChErlaubt = 2^13, ChUmschichtenAuf = 2^15
const ChUmschichtenAb = 2^16, ChLegeEinmal = 2^17, ChAniOffen = 2^18, ChAniVerdeckt = 2*2^18
const ChAniFrei = ChAniOffen or ChAniVerdeckt, ChVerdeckt = 2^20, ChOffen = 2^21, ChSpielende = 2^22
const EndeSieg = 1, EndeVerlust = 2, EndeSpeichern = 3, EndeNeu = 4, EndeSiegUndNeu = 5
const EndeFileNotFound = 6, EndeFehler = 0
const Offen = 0, Leer = 1, Verdeckt = 2
const Hintergrund2 = 1
const Herz = 1, Kreuz = 2, Karo = 3, Pik = 4, Rot = 5, Schwarz = 6
const K2 = 2, K3 = 3, K4 = 4, K5 = 5, K6 = 6, K7 = 7, K8 = 8, K9 = 9, K10 = 10, KB = 11, KD = 12, KK = 13, KA = 14
const TStapel = 0, TStock = 1, TAbwurf = 2, TGrund = 3, THilf = 4, TKeller = 5, TReserve = 6
const SOUND_MUSIK_OK = 1, SOUND_MUSIK_ON = 2, SOUND_EFFEKT_OK = 4, SOUND_EFFEKT_ON = 8
const BRand = 1, BGrau = 2

type TypButton
  as integer x, y, b, h, opt
  as string text
  declare constructor
  declare constructor(x as integer, y as integer, b as integer, h as integer, opt as integer, text as string)
  declare function in(x as integer, y as integer) as integer
  declare sub zeichnen(mark as integer = 0)
end type
constructor TypButton
  this = type<TypButton>(-1, -1, 0, 0, BRand, "")
end constructor
constructor TypButton(x as integer, y as integer, b as integer, h as integer, opt as integer, text as string)
  this.x = x
  this.y = y
  this.b = b
  this.h = h
  this.text = text
  this.opt = opt
end constructor
function TypButton.in(x as integer, y as integer) as integer
  if (x >= this.x) and (x <= this.x + this.b) and (y >= this.y) and (y <= this.y + this.h) then return -1
  return 0
end function
sub TypButton.zeichnen(mark as integer = 0)
  dim as integer whoehe, zhoehe, farbe1, farbe2, farbe3
  screeninfo , whoehe
  zhoehe = whoehe \ hiword(width)
  if this.h > 0 then
    select case mark
      case 0 : farbe1 = FGC   : farbe2 = BGC   : farbe3 = FGC   ' normal
      case 1 : farbe1 = FGC   : farbe2 = FGC   : farbe3 = BGC   ' aktiv
      case 2 : farbe1 = FGC   : farbe2 = DGRAU : farbe3 = HGRAU ' markiert
      case 3 : farbe1 = DGRAU : farbe2 = BGC   : farbe3 = DGRAU ' deaktiviert
    end select
    line (this.x, this.y)-step(this.b-2, this.h-2), farbe2, bf
    line (this.x, this.y)-step(this.b-1, this.h-1), farbe1, b
    if this.opt and BRand then line (this.x+1, this.y+1)-step(this.b-3, this.h-3), farbe1, b
    draw string (this.x+this.b\2 - 4*len(this.text) + 1, this.y+this.h\2 - zhoehe\2 + 1), this.text, farbe3
  else
    line (this.x, this.y)-step(this.b-1, 16), BGC, bf
    draw string (this.x+this.b\2 - 4*len(this.text), this.y + 1), this.text
  end if
end sub

function ersetzeZeichenkette(text as string, alt as string, neu as string) as string
  dim z as uinteger, ret as string = text
  do
    z = instr(ret, alt)
    if z = 0 then exit do
    ret = left(ret, z-1) & neu & mid(ret, z+len(alt))
  loop
  return ret
end function

sub ersetzeUmlaute(byref text as string, fenster as integer = 0)
  if fenster = 0 then
    text = ersetzeZeichenkette(text, chr(195, 164), chr(132))
    text = ersetzeZeichenkette(text, chr(195, 182), chr(148))
    text = ersetzeZeichenkette(text, chr(195, 188), chr(129))
    text = ersetzeZeichenkette(text, chr(195, 132), chr(142))
    text = ersetzeZeichenkette(text, chr(195, 150), chr(153))
    text = ersetzeZeichenkette(text, chr(195, 156), chr(154))
    text = ersetzeZeichenkette(text, chr(195, 159), chr(225))
  else
    text = ersetzeZeichenkette(text, chr(195, 164), chr(228))
    text = ersetzeZeichenkette(text, chr(195, 182), chr(246))
    text = ersetzeZeichenkette(text, chr(195, 188), chr(252))
    text = ersetzeZeichenkette(text, chr(195, 132), chr(196))
    text = ersetzeZeichenkette(text, chr(195, 150), chr(214))
    text = ersetzeZeichenkette(text, chr(195, 156), chr(220))
    text = ersetzeZeichenkette(text, chr(195, 159), chr(223))
    text = ersetzeZeichenkette(text, chr(132), chr(228))
    text = ersetzeZeichenkette(text, chr(148), chr(246))
    text = ersetzeZeichenkette(text, chr(129), chr(252))
    text = ersetzeZeichenkette(text, chr(142), chr(196))
    text = ersetzeZeichenkette(text, chr(153), chr(214))
    text = ersetzeZeichenkette(text, chr(154), chr(220))
    text = ersetzeZeichenkette(text, chr(225), chr(223))
  end if
end sub

function nachricht(meldung as string, buttons as string = " OK ") as integer
  ' gibt eine Meldung mit bis zu 5 Zeilen mit bis zu 3 Antwortmoeglichkeiten aus
  ' ACHTUNG: wurde nicht unter Extrembedingungen (uebergrosse Texte) getestet!
  dim as integer textzahl, such, textlaenge, buttonlaenge, breite, hoehe, startx, starty
  dim as integer mx, my, mb, mx2, my2, fensterW, fensterH
  dim txt(1 to 5) as string, buttontxt(1 to 3) as string, buttonx(1 to 3) as integer
  screeninfo breite, hoehe
  dim as integer zhoehe = hoehe \ hiword(width)
  ' Button-Texte zusammenstellen
  buttontxt(1) = buttons
  ersetzeUmlaute buttontxt(1)
  such = instr(buttontxt(1), "\n")
  if such = 0 then
    buttontxt(1) = left(buttontxt(1), breite\10)
    buttontxt(2) = ""
    buttontxt(3) = ""
  else
    buttontxt(2) = mid(buttontxt(1), such+2)
    buttontxt(1) = left(buttontxt(1), iif(such <= breite\30, such-1, breite\30))
    such = instr(buttontxt(2), "\n")
    if such = 0 then
      buttontxt(3) = ""
    else
      buttontxt(3) = mid(buttontxt(2), such+2)
      buttontxt(2) = left(buttontxt(2), iif(such <= breite\30, such-1, breite\30))
    end if
  end if
  for i as integer = 1 to 3
    ersetzeUmlaute buttontxt(i)
  next
  txt(1) = meldung
  ersetzeUmlaute txt(1)
  ' Text auseinandernehmen
  for textzahl = 1 to 4
    such = instr(txt(textzahl), "\n")
    if such > 0 then
      txt(textzahl+1) = mid(txt(textzahl), such+2)
      txt(textzahl) = left(txt(textzahl), such-1)
      if textlaenge < such-1 then textlaenge = such-1
    else
      exit for
    end if
  next
  if textlaenge < len(txt(textzahl)) then textlaenge = len(txt(textzahl))
  for i as integer = 1 to 3
    if buttonlaenge < len(buttontxt(i)) then buttonlaenge = len(buttontxt(i))
  next
  ' Fensterbreite abhaengig von der Meldungslaenge
  if textlaenge > breite\8 - 2 then textlaenge = breite\8 - 2
  startx = breite\2 - 4*textlaenge - 10
  starty = hoehe\2 - 10*textzahl - 35
  fensterW = breite-2*startx+4
  fensterH = hoehe-2*starty+14
  ' Fensterbreite abhaengig von der Laenge der Buttuns
  if buttontxt(3) <> "" then
    if fensterW < buttonlaenge*24 + 85 then fensterW = buttonlaenge*24 + 85
    startx = (breite-fensterW)\2 - 4
  elseif buttontxt(2) <> "" then
    if fensterW < buttonlaenge*16 + 50 then fensterW = buttonlaenge*16 + 50
    startx = (breite-fensterW)\2 - 4
  else
    if fensterW < buttonlaenge*8 + 30 then fensterW = buttonlaenge*8 + 30
    startx = (breite-fensterW)\2 - 4
  end if
  ' Test, ob die ermittelte Laenge erlaubt ist
  if fensterW >= breite then return 0
  if fensterH >= hoehe then return 0
  ' Positionen der Buttons bestimmen
  if buttontxt(3) <> "" then
    if textlaenge < 3*buttonlaenge + 9 then textlaenge = 3*buttonlaenge + 9
    buttonx(1) = fensterW\2 - buttonlaenge*12 - 32
    buttonx(2) = fensterW\2 - buttonlaenge*4 - 7
    buttonx(3) = fensterW\2 + buttonlaenge*4 + 18
  elseif buttontxt(2) <> "" then
    if textlaenge < 2*buttonlaenge + 6 then textlaenge = 2*buttonlaenge + 6
    buttonx(1) = fensterW\2 - buttonlaenge*8 - 16
    buttonx(2) = fensterW\2 + 8
    buttonx(3) = -1
  else
    if textlaenge < buttonlaenge + 3 then textlaenge = buttonlaenge + 3
    buttonx(1) = fensterW\2 - buttonlaenge*4 - 5
    buttonx(2) = -1
    buttonx(3) = -1
  end if
  ' Fenster zeichnen
  dim as any ptr speicher  = imagecreate(fensterW, fensterH)
  dim as any ptr speicher2 = imagecreate(fensterW, fensterH)
  get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher
  line (startx-2, starty-2)-step(fensterW-1, fensterH-1), MBC, bf
  line (startx, starty)-step(fensterW-5, fensterH-5),, b
  line (startx+2, starty+2)-step(fensterW-9, fensterH-9),, b
  line (startx+3, starty+3)-step(fensterW-11, fensterH-11),, b
  for i as integer = 1 to textzahl
    draw string (startx + 12, starty + i*20 - 8 + (16-zhoehe)\2), left(txt(i), textlaenge)
  next
  for i as integer = 1 to 3
    if buttonx(i) > -1 then
      line (startx + buttonx(i), starty + fensterH - 46)-step(buttonlaenge*8+10, 23),, b
      line (startx + buttonx(i)+1, starty + fensterH - 45)-step(buttonlaenge*8+8, 21),, b
      draw string (startx+buttonx(i)+(buttonlaenge-len(buttontxt(i)))*4+6, _
           starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(i)
    end if
  next
  get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher2
  dim wahl as integer, taste as string
  ' Interaktion
  do
    do
      wahl = -1
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb < 1
      ' Auf Mausdruck warten
      do
        getmouse mx, my,, mb
        taste = inkey
        sleep 1
      loop until mb = 1 or taste = chr(13) or taste = chr(27)
      if taste = chr(13) then wahl = 1 : exit do, do
      if taste = chr(27) then
        for i as integer = 3 to 1 step -1
          if buttontxt(i) <> "" then wahl = i : exit do, do
        next
      end if
      ' Button oder Fenster angeklickt?
      for i as integer = 1 to 3
        if buttonx(i) >= 0 andalso _
            mx > startx + buttonx(i) and my > starty + fensterH - 46 _
                 and mx < startx + buttonx(i) + buttonlaenge*8+10 and my < starty + fensterH - 23 then
          wahl = i
          line (startx + buttonx(i)+1, starty + fensterH - 45)-step(buttonlaenge*8+8, 21),, bf
          draw string (startx + buttonx(i)+(buttonlaenge-len(buttontxt(i)))*4+6, _
               starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(i), MBC
        end if
      next
      if wahl < 0 and (mx < startx or my < starty or mx > startx + fensterW or my > starty + fensterH) then wahl = 0
      ' auf Loslassen der Maus warten
      do
        getmouse mx2, my2,, mb
        if wahl = -1 then
          ' Fenster verschieben
          if mb < 0 then mb = 0 :  exit do
          if (mx2 <> mx or my2 <> my) then
            screenlock
            put (startx-2, starty-2), speicher, pset
            startx += mx2 - mx
            starty += my2 - my
            if startx < 2 then startx = 2
            if starty < 2 then starty = 2
            if startx >= breite - fensterW + 1 then startx = breite - fensterW + 1
            if starty >= hoehe - fensterH + 1 then starty = hoehe - fensterH + 1
            get (startx-2, starty-2)-step(fensterW-1, fensterH-1), speicher
            put (startx-2, starty-2), speicher2, pset
            screenunlock
            mx = mx2
            my = my2
          end if
        end if
        sleep 1
      loop until mb = 0
    loop until wahl >= 0
    if wahl = 0 then continue do
    line (startx + buttonx(wahl)+2, starty + fensterH - 44)-step(buttonlaenge*8+6, 19), MBC, bf
    draw string (startx + buttonx(wahl)+(buttonlaenge-len(buttontxt(wahl)))*4+6, _
                starty + fensterH - 42 + (16-zhoehe)\2), buttontxt(wahl)
    if mx2 > startx + buttonx(wahl) and my2 > starty + fensterH - 46 _
            and mx2 < startx + buttonx(wahl) + buttonlaenge*8+10 and my2 < starty + fensterH - 23 then exit do
  loop
  put (startx-2, starty-2), speicher, pset
  imagedestroy speicher
  imagedestroy speicher2
  return wahl
end function

sub richtungsadd(r as integer, byref x as integer, byref y as integer, _
                 oadd as integer, uadd as integer, ladd as integer, radd as integer)
  ' addiert je nach Richtung r zu x und y Anpassungswerte
  if r and ROben  then : y += oadd : elseif r and RUnten  then : y += uadd : end if
  if r and RLinks then : x += ladd : elseif r and RRechts then : x += radd : end if
end sub

function sucheRichtung(text as string) as integer
  dim as integer ret = 0
  if instr(text, "oben") then ret or= ROben
  if instr(text, "unten") then ret or= RUnten
  if instr(text, "links") then ret or= RLinks
  if instr(text, "rechts") then ret or= RRechts
  return ret
end function
